import { BaseProviderAPI } from "./BaseProviderAPI";
import { ISerializers } from "./entitySerializers";
import { CreateParams, DeleteManyParams, DeleteParams, GetManyParams, GetManyReferenceParams, GetOneParams, IProvider, ListParams, ProviderOptions, Record, UpdateManyParams, UpdateParams } from "./types";
export interface ProviderFileListOptions extends ProviderOptions {
    serializer: keyof ISerializers;
}
export declare class BaseProviderFileList implements IProvider {
    private readonly api;
    private readonly projectId;
    private readonly ref;
    private readonly basePath;
    private readonly cacheStore;
    private readonly serializer;
    constructor(api: BaseProviderAPI, { projectId, ref, basePath, serializer }: ProviderFileListOptions);
    getList(params?: ListParams): Promise<{
        data: Record[];
        total: number;
    }>;
    getOne(params: GetOneParams): Promise<{
        data: Record;
    }>;
    getMany(params: GetManyParams): Promise<{
        data: Record[];
    }>;
    getManyReference(params: GetManyReferenceParams): Promise<{
        data: Record[];
        total: number;
    }>;
    create(params: CreateParams): Promise<{
        data: Record;
    }>;
    update(params: UpdateParams): Promise<{
        data: {
            id: string;
        };
    }>;
    updateMany(params: UpdateManyParams): Promise<{
        data: {
            id: string | number;
        }[];
    }>;
    delete(params: DeleteParams): Promise<{
        data: {
            id: string;
        };
    }>;
    deleteMany(params: DeleteManyParams): Promise<{
        data: string[];
    }>;
    private createEntity;
    private parseEntity;
    private stringifyEntity;
    private getFilePath;
}
