export const cacheStoreGetOrSet = async (cacheStore, key, getFn, checkFn) => {
    const cached = await cacheStore.getItem(key);
    if (cached) {
        const check = typeof checkFn === "function" ? checkFn(cached) : true;
        if (check) {
            return cached;
        }
        else {
            console.warn('cached invalidation for', key);
        }
    }
    const value = await getFn();
    await cacheStore.setItem(key, value);
    return value;
};
