import { CreateParams, DeleteManyParams, DeleteParams, GetManyParams, GetManyReferenceParams, GetOneParams, IProvider, ListParams, ProviderOptions, Record, UpdateManyParams, UpdateParams } from "../../types";
export declare class ProviderBranch implements IProvider {
    private readonly branches;
    private readonly projectId;
    constructor({ gitlabOptions, projectId }: ProviderOptions);
    getList(params: ListParams): Promise<{
        data: Record[];
        total: number;
    }>;
    getOne(params: GetOneParams): Promise<{
        data: Record;
    }>;
    getMany(params: GetManyParams): Promise<{
        data: Record[];
    }>;
    getManyReference(params: GetManyReferenceParams): Promise<{
        data: Record[];
        total: number;
    }>;
    create(params: CreateParams): Promise<{
        data: {
            id: string;
        };
    }>;
    update(params: UpdateParams): Promise<{
        data: {
            id: string;
        };
    }>;
    updateMany(params: UpdateManyParams): Promise<{
        data: {
            id: string;
        }[];
    }>;
    delete(params: DeleteParams): Promise<{
        data: {
            id: string;
        };
    }>;
    deleteMany(params: DeleteManyParams): Promise<{
        data: string[];
    }>;
}
