import { Branches } from "gitlab";
import { getToken } from "./authProvider";
export class ProviderBranch {
    constructor({ gitlabOptions, projectId }) {
        this.projectId = projectId;
        this.branches = new Branches(Object.assign({}, gitlabOptions, { oauthToken: getToken() }));
    }
    async getList(params) {
        const branchList = (await this.branches.all(this.projectId, {
            search: "",
        }));
        const branches = branchList.map(branch => (Object.assign({}, branch, { id: branch.name })));
        return {
            data: branches,
            total: branches.length,
        };
    }
    async getOne(params) {
        const rawBranch = (await this.branches.show(this.projectId, params.id));
        const branch = Object.assign({}, rawBranch, { id: rawBranch.name });
        return {
            data: branch,
        };
    }
    async getMany(params) {
        return {
            data: (await Promise.all(params.ids.map(async (id) => (await this.getOne({ id })).data))),
        };
    }
    async getManyReference(params) {
        return this.getList(Object.assign({}, params, { filter: Object.assign({ [params.target]: params.id }, params.filter) }));
    }
    async create(params) {
        throw new Error("Not available");
        return {
            data: {
                id: "string",
            },
        };
    }
    async update(params) {
        throw new Error("Not available");
        return {
            data: {
                id: "string",
            },
        };
    }
    async updateMany(params) {
        throw new Error("Not available");
        return {
            data: [
                {
                    id: "string",
                },
            ],
        };
    }
    async delete(params) {
        throw new Error("Not available");
        return {
            data: {
                id: "string",
            },
        };
    }
    async deleteMany(params) {
        throw new Error("Not available");
        return {
            data: ["string"],
        };
    }
}
