import { CreateParams, DeleteManyParams, DeleteParams, GetManyParams, GetManyReferenceParams, GetOneParams, IProvider, ListParams, ProviderOptions, Record, UpdateManyParams, UpdateParams } from "../../types";
interface ICommit {
    id: string;
}
export declare class ProviderCommit implements IProvider {
    private readonly commits;
    private readonly projectId;
    private readonly ref;
    constructor({ gitlabOptions, projectId, ref }: ProviderOptions);
    getList(params: ListParams): Promise<{
        data: ICommit[];
        total: number;
    }>;
    getOne(params: GetOneParams): Promise<{
        data: ICommit;
    }>;
    getMany(params: GetManyParams): Promise<{
        data: Record[];
    }>;
    getManyReference(params: GetManyReferenceParams): Promise<{
        data: ICommit[];
        total: number;
    }>;
    create(params: CreateParams): Promise<{
        data: {
            id: string;
        };
    }>;
    update(params: UpdateParams): Promise<{
        data: {
            id: string;
        };
    }>;
    updateMany(params: UpdateManyParams): Promise<{
        data: {
            id: string;
        }[];
    }>;
    delete(params: DeleteParams): Promise<{
        data: {
            id: string;
        };
    }>;
    deleteMany(params: DeleteManyParams): Promise<{
        data: string[];
    }>;
}
export {};
