import { Commits } from "gitlab";
import { getToken } from "./authProvider";
export class ProviderCommit {
    constructor({ gitlabOptions, projectId, ref }) {
        this.projectId = projectId;
        this.commits = new Commits(Object.assign({}, gitlabOptions, { oauthToken: getToken() }));
        this.ref = ref;
    }
    async getList(params) {
        const commits = (await this.commits.all(this.projectId, {
            ref: this.ref,
        }));
        return {
            data: commits,
            total: commits.length,
        };
    }
    async getOne(params) {
        const commit = (await this.commits.show(this.projectId, params.id));
        return {
            data: commit,
        };
    }
    async getMany(params) {
        return {
            data: (await Promise.all(params.ids.map(async (id) => (await this.getOne({ id })).data))),
        };
    }
    async getManyReference(params) {
        return this.getList(Object.assign({}, params, { filter: Object.assign({ [params.target]: params.id }, params.filter) }));
    }
    async create(params) {
        throw new Error("Not available");
        return {
            data: {
                id: "string",
            },
        };
    }
    async update(params) {
        throw new Error("Not available");
        return {
            data: {
                id: "string",
            },
        };
    }
    async updateMany(params) {
        throw new Error("Not available");
        return {
            data: [
                {
                    id: "string",
                },
            ],
        };
    }
    async delete(params) {
        throw new Error("Not available");
        return {
            data: {
                id: "string",
            },
        };
    }
    async deleteMany(params) {
        throw new Error("Not available");
        return {
            data: ["string"],
        };
    }
}
